require "ChyrGUI"
gui = {}

function gui.load()
	key_ctr = 0
	mainPanel = CGPanel.create()
	mainPanel.posX = 0
	mainPanel.posY = 0
	mainPanel.width = 800
	mainPanel.height = 600
	mainPanel.bgColor.r = 68
	mainPanel.bgColor.g = 149
	mainPanel.bgColor.b = 205
	testLabel = CGLabel:create("Hallo Welt. Das ist der Inhalt von Tab 1")
	testLabel2 = CGLabel:create("Tab 2 Inhalt")
	testLabel3 = CGLabel:create("Mehr inhalt fuer Tab3")
	
	x_label = CGLabel:create("")
	y_label = CGLabel:create("")
	grey_label = CGLabel:create("")
	grey_label.posY = 80
	grey_label.posX = 100
	x_label.posY = 80
	y_label.posY = 80
	y_label.posX = 50
	--testLabel.text = "Hallo Welt. Das ist der Inhalt von Tab 1"
	tabPanel = CGPanel:create()
	tabPanel.bgColor.r = 190
	tabPanel.bgColor.g = 190
	tabPanel.bgColor.b = 190
	tabPanel:addWidget(testLabel)
	tabPanel:addWidget(x_label)
	tabPanel:addWidget(y_label)
	tabPanel:addWidget(grey_label)
	tabPanel2 = CGPanel:create()
	tabPanel2.bgColor.r = 190
	tabPanel2.bgColor.g = 190
	tabPanel2.bgColor.b = 190
	tabPanel2:addWidget(testLabel2)
	tabPanel3 = CGPanel:create()
	tabPanel3.bgColor.r = 190
	tabPanel3.bgColor.g = 190
	tabPanel3.bgColor.b = 190
	tabPanel3:addWidget(testLabel3)
	mainTabs = CGTabs.create()
	mainTabs.height = 600
	mainTabs.width = 800
	tabPanel2.onMouseDown = function(x,y,button) testLabel2.visible = not testLabel2.visible end
	mainTabs:addTab("Image", tabPanel)
	mainTabs:addTab("Table", tabPanel2)
	mainTabs:addTab("Info", tabPanel3)
	mainPanel:addWidget(mainTabs)
	
	myCanvas = CGCanvas:create(256,256)
	myCanvas.posX, myCanvas.posY = 250, 100
	
	
	myCanvas2 = CGCanvas:create(256,256)
	myCanvas2.posX, myCanvas2.posY = 250, 100
	
	tabPanel:addWidget(myCanvas)
	tabPanel:addWidget(myCanvas2)
	
	myImg = love.graphics.newImage("assets/graphics/mark.png")
	myImg:setFilter("nearest","nearest")
	
	love_logo = love.graphics.newImage("assets/graphics/love.png")
	love_logo:setFilter("nearest","nearest")
	
	myCanvas:paint({love_logo,0,0})
	myCanvas.resetAfterDraw = false
	
	dot_list = {}
	
	myButton = CGButton:create()
	myButton.posX, myButton.posY, myButton.width, myButton.height = 50, 100, 100, 50
	myButton:setText("Hallo Welt!")
	tabPanel:addWidget(myButton)
	
	myButton2 = CGButton:create()
	myButton2.posX, myButton2.posY, myButton2.width, myButton2.height = 100, 100, 0,0
	myButton2:setImage(love_logo)
	tabPanel:addWidget(myButton2)
	
	
	
	myCanvas.onMouseOver = function(x,y) 
		x_label.text = tostring(x)
		y_label.text = tostring(y)
		idata = myCanvas.canvas:getImageData()
		pr,pg,pb,_  = idata:getPixel(x,y)
		grey_label.text = tostring(math.floor((pr+pg+pb)/3+0.5))
	end
	
	myCanvas.onMouseNotOver = function(x,y) 
		x_label.text = ""
		y_label.text = ""
		grey_label.text = ""
	end
	
	myScroll = CGScrollbar:create(200)
	myScroll.posX, myScroll.posY = 50,150
	tabPanel:addWidget(myScroll)
	
	myList = CGListContainer:create({"x Pos","y Pos", "grey value", "image"}, {}, 10)
	myList.posX = 50
	myList.posY = 355
	tabPanel:addWidget(myList)
	
	myCanvas.onMouseDown = function(x,y,button) 
		table.insert(dot_list,{x,y})
		idata = myCanvas.canvas:getImageData()
		pr,pg,pb,_  = idata:getPixel(x,y)
		myList:addRow({x,y,tostring(math.floor((pr+pg+pb)/3+0.5)),"LOVE"})
	end
	
end

function gui.draw()
	mainPanel:draw()
end

function gui.doSomething()
	testLabel.text = "Hallo Welt. Das ist der Inhalt von Tab 1\nFPS:"..love.timer.getFPS()
end

function gui.rectfunc()
	for _,v in ipairs(dot_list) do
		love.graphics.draw(myImg, v[1]-1, v[2]-1)
	end
end

function gui.update(dt)
	if (love.keyboard.isDown("left")) then
		key_ctr = key_ctr + dt
		if (key_ctr > 1/25) then
			nv = math.floor(key_ctr/(1/25))
			myScroll:setValue(myScroll.value - nv)
			key_ctr = key_ctr - nv/25
			testLabel.text = tostring(myScroll.value)
		end
	end
	if (love.keyboard.isDown("right")) then
		key_ctr = key_ctr + dt
		if (key_ctr > 1/25) then
			nv = math.floor(key_ctr/(1/25))
			myScroll:setValue(myScroll.value + nv)
			key_ctr = key_ctr - nv/25
			testLabel.text = tostring(myScroll.value)
		end
	end
	myCanvas2:paint_func(gui.rectfunc,{})
	mainPanel:_onMouseOver(love.mouse.getX(),love.mouse.getY(), love.mouse.isDown())
end

function gui.keypressed(button)
	if (button == "left" or button == "right") then
		key_ctr = 0
	end
end

function gui.mousepressed( x, y, button )
	if (button == "r" or button == "l" or button == "m") then
		mainPanel:_onMouseDown(x,y,button)
	end
	if (button == "wd") then
		mainPanel:_onScrollDown(x,y,button)
	end
	if (button == "wu") then
		mainPanel:_onScrollUp(x,y,button)
	end
end

function gui.mousereleased( x, y, button )
	if (button == "r" or button == "l" or button == "m") then
		mainPanel:_onMouseUp(x,y,button)
	end
end